// I2CBusMaster.h: Definition of the I2CBusMaster class
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_I2CBUSMASTER_H__2E04C582_5EC1_11D1_875E_00A024CF1ED8__INCLUDED_)
#define AFX_I2CBUSMASTER_H__2E04C582_5EC1_11D1_875E_00A024CF1ED8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "resource.h"       // main symbols

#include "..\Driver\I2C.h"

/////////////////////////////////////////////////////////////////////////////
// CI2CBusMaster

class CI2CBusMaster : 
	public CComDualImpl<II2CBusMaster, &IID_II2CBusMaster, &LIBID_COMI2CLib>, 
	public ISupportErrorInfo,
	public CComObjectRoot,
	public CComCoClass<CI2CBusMaster,&CLSID_I2CBusMaster>
{
public:
	CI2CBusMaster() {}
BEGIN_COM_MAP(CI2CBusMaster)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(II2CBusMaster)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()
//DECLARE_NOT_AGGREGATABLE(I2CBusMaster) 
// Remove the comment from the line above if you don't want your object to 
// support aggregation. 

DECLARE_REGISTRY_RESOURCEID(IDR_I2CBusMaster)
// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);
	STDMETHOD(Open)(BSTR lpszComDevice);
	STDMETHOD(Close)();
	STDMETHOD(TransmitData)(VARIANT_BOOL bSendStop, unsigned char Address, short BytesToSend, unsigned char *SourceData, VARIANT_BOOL *pRetVal);
	STDMETHOD(ReceiveData)(unsigned char Address, short BytesToReceive, unsigned char *DataPtr, VARIANT_BOOL *pRetVal);

// II2CBusMaster
private:

	I2CContext m_driverContext;
};

#endif // !defined(AFX_I2CBUSMASTER_H__2E04C582_5EC1_11D1_875E_00A024CF1ED8__INCLUDED_)
